package core

import (
	"git.sr.ht/~cco/go-scopes/config"
	"git.sr.ht/~cco/go-scopes/lib"
	"git.sr.ht/~cco/go-scopes/lib/action"
	"git.sr.ht/~cco/go-scopes/logging/log"
)

func Start(ctx lib.Context) {
	log.Debug().Str("service", ctx.Config().Name()).Msg("core.Start")
	lib.RunCtx(ctx, Listen)
}

func Listen(ctx lib.Context) {
	step := ctx.Config().Step()
	for step(ctx) {
	}
}

func Step(ctx lib.Context) (loop bool) {
	loop = true
	//defer ctx.LogCatch("Step")
	select {
	case msg := <-ctx.Mailbox():
		loop = lib.HandleMsg(ctx, msg)
	case <-ctx.Done():
		loop = false
	}
	return
}

func HandleMessage(ctx lib.Context, msg lib.Message) (loop bool) {
	loop = true
	log.Debug().Str("service", ctx.Config().Name()).Str("msg.action", msg.Action()).
		Msg("core.HandleMessage")
	for _, act := range action.Select(ctx, msg) {
		loop = act.Handle()
	}
	return
}

func init() {
	config.Step = Step // avoid import cycle
	config.MsgHandler = HandleMessage
}
